<!-- Copyright (c) Vincent Dardel, <vindarez@mailz.org>,  Abelujo Developers-->
<!-- See the COPYRIGHT file at the top-level directory of this distribution-->
<!-- Abelujo is free software: you can redistribute it and/or modify-->
<!-- it under the terms of the GNU Affero General Public License as published by-->
<!-- the Free Software Foundation, either version 3 of the License, or-->
<!-- (at your option) any later version.-->
<!-- Abelujo is distributed in the hope that it will be useful,-->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of-->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the-->
<!-- GNU Affero General Public License for more details.-->
<!-- You should have received a copy of the GNU Affero General Public License-->
<!-- along with Abelujo.  If not, see <http://www.gnu.org/licenses/>.-->


{% extends "base.html" %}

{% block pagetitle %}
Abelujo - Institutions
{% endblock %}

{% block content %}
{% load i18n %}

{% load bootstrap3 %}
{% bootstrap_css %}
{% bootstrap_javascript %}
{% load ngfilter %}
{% get_current_language as LANGUAGE_CODE %}
{% load currencyfilter %}

<!-- XXX: remove Angular -->


<div id="toplevel-messages">
  {% if messages %}
  <ul class="messages">
    {% for msg in messages %}
    <uib-alert type="success">{{ msg }}</uib-alert>
    {% endfor %}
  </ul>
  {% endif %}
</div>

<div>
  <div class="row">

    <h3> {% trans "Commandes Institutions" %} </h3>

    <div class="col-md-3">

      <!-- Grouped by clients: a client => a list of baskets. -->

      {% for it in grouped_baskets %}
      <ul class="list-group">
        <li class="list-group-item"
            uib-popover="{{'baskets[$index].comment'|ng}}"
            popover-trigger="mouseenter"
            popover-placement="right" >
          {{ it.0 }}
        </li>

        <ul class="list-group" style="padding-left: 32px">
          {% for basket in it.1 %}
          <li class="list-group-item mouse-pointer">
            <a hx-get="/{{ LANGUAGE_CODE }}/institutions/baskets/{{ basket.pk }}"
                hx-target="#list-content">
              {% trans "Command" %}: {{ basket.name }}
              <!-- <span class="badge"> {{ books_nb }} </span> -->
            </a>
            {% endfor %}
          </li>
        </ul>

      </ul>
      {% endfor %}
    </div>

    <div id="list-content">
      <div class="col-md-9">
        <div class="row">

          <div class="col-md-5">
            <div class="btn-group">
              <div class="dropdown">
                <button
                    id="action-button-id" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn btn-info dropdown-toggle">
                  {% trans "Action" %}
                  <span class="caret"></span>
                </button>

                <ul class="dropdown-menu">
                  <li>
                    <a hx-post="/api/institutions/lists/{{ basket.pk }}?action=command"
                        hx-target="#list-content"
                        title="{% trans "Mark all the cards to command" %}">
                      {% trans "Command…" %}</a>
                  </li>

                  <li role="separator" class="divider"></li>
                  <li><a
                          href="#"
                          onclick="empty_basket()"
                          title="{% trans "Empty this list." %}">
                    {% trans "Empty this list" %}</a>
                  </li>
                  <li><a
                          href="#"
                          onclick="archive_basket()"
                          title="{% trans "Archive this list." %}">
                    {% trans "Archive this list" %}</a>
                  </li>
                </ul>

              </div>
            </div>
            <div class="btn-group">
              <div class="dropdown">
                <button
                    data-toggle="dropdown" type="button" aria-haspopup="true" aria-expanded="false" title="{% trans 'Export the list to the required format' %}" class="btn btn-success dropdown-toggle">{% trans "Export" %}<span class="caret"></span>
                </button>
                <ul class="dropdown-menu">
                  <li><a href="/baskets/{{ 'cur_basket.id' | ng}}/export?format=txt&report=listing">txt</a>
                  </li>
                  <li><a href="/baskets/{{ 'cur_basket.id' | ng}}/export?format=csv&report=listing">{% trans "List" %} - csv</a>
                  </li>
                  <li><a href="/baskets/{{ 'cur_basket.id' | ng}}/export?format=csv&report=simplelisting">{% trans "isbn and quantity (Dilicom)" %} - csv</a>
                  </li>
                  <li><a
                          href="/baskets/{{ 'cur_basket.id' | ng}}/export?format=pdf&report=listing&barcodes=true"
                      >
                    {% trans "List, with barcodes" %} - pdf
                  </a>
                  </li>
                  <li><a
                          href="/baskets/{{ 'cur_basket.id' | ng}}/export?format=pdf&report=listing&barcodes=false&covers=true"
                      >
                    {% trans "List, with covers" %} - pdf</a>
                  </li>

                  <li role="separator" class="divider"></li>

                  <li>
                    <a data-comment="bon de livraison"
                        href="/baskets/{{ 'cur_basket.id' | ng}}/export?format=pdf&report=listing&shippingreceipt=true&barcodes=true&covers=false"
                        title="{% trans 'Create a shipping receipt' %}">
                      {% trans "Shipping receipt" %}
                    </a>
                  </li>

                  <li><a href="#"
                          onclick="choose_client_for_bill(cur_basket.id, 1)"
                          title="{% trans "Create a bill for a client" %}">
                    {% trans "Bill" %}…</a>
                  </li>

                  <li><a href="#" ng-click="choose_client_for_estimate(cur_basket.id, 2)" title="{% trans "Create an estimate for a client" %}">{% trans "Estimate" %}…</a>
                  </li>

                </ul>
              </div>
            </div>

            <div id="import-menu" class="btn-group">
              <div class="dropdown">
                <button
                    data-toggle="dropdown" type="button" aria-haspopup="true" aria-expanded="false" title="{% trans 'Import files' %}" class="btn btn-success dropdown-toggle">{% trans "Import" %}<span class="caret"></span>
                </button>
                <ul class="dropdown-menu">
                  <li><a href="/import?source=institutions&id={{ 'cur_basket.id' | ng }}" title="">{% trans "isbn and quantity (Dilicom)" %} - csv</a>
                  </li>
                </ul>
              </div>
            </div>

            <div class="btn-group">
              <!-- <button ng-click="toggle_images()" title="{% trans "Hide and show covers (d)" %}" class="btn btn-default"><i class="glyphicon glyphicon-th-list"></i>
                   </button>
                   <button type="button" title="{% trans "Show your notes (n)" %}" class="btn btn-default"><i class="glyphicon glyphicon-pencil"></i> -->
                </button><a href="http://abelujo.cc/docs/lists/" target="_blank" title="{% trans "Read the documentation" %}" class="btn btn-default"><i class="glyphicon glyphicon-question-sign"></i></a>
            </div>
          </div>

          <!--
               <div class="col-md-7">
               <form>
               <p class="input-group">
               <input id="default-input"
               type="text"
               typeahead-loading="loadingCards"
               ng-model="copy_selected"
               uib-typeahead="copy.repr for copy in getCards($viewValue)"
               typeahead-template-url="customTemplate.html"
               typeahead-min-length="3"
               typeahead-wait-ms="300"
               typeahead-on-select="add_selected_card($item)"
               title="{% trans 'Use TAB to validate your choice, Enter to proceed.' %}"
               id="default-input"
               autocomplete="off"
               placeholder="{% trans "Search any isbn, search by keywords in your stock" %}"
               class="nullable form-control"/>
               <span class="input-group-btn">
               <button type="button" class="btn btn-default"><i class="glyphicon glyphicon-search"></i>
               </button></span>
               </p>
               </form>
               </div>
          -->

        </div>

        <div><span ng-show="cur_basket.created">{% trans "Created" %}: {{ 'cur_basket.created | date: "mediumDate"' | ng }}</span>
          <span ng-show="selected_client">&nbsp;&bull; {% trans "Client" %}: {{ 'selected_client' | ng }}</span>

          {% if archived_on %}
          <span id="archived_on_id">&nbsp;&bull; {% trans "Archived on" %}: {{ 'cur_basket.archived_date' | ng }}</span><span ng-show="cur_basket.dist_repr"><span>&nbsp;&bull; {% trans "supplier" %}: <span id="supplier" style="padding: 3px">{{ 'cur_basket.dist_repr' | ng }}</span></span></span>
          {% endif %}
        </div>

        {% if weight %}
        <div ng-hide="cur_basket.id == -99" ng-show="( boxes_page || returns_page ) && meta.total_weight_kg">{% trans "Weight:" %}  {{ 'meta.total_weight_kg' | ng }}Kg</div>
        {% endif %}

        {% if comment %}
        <div class="media" ng-show="cur_basket.comment && ! showing_notes" style="margin: 5px">
          <div class="media-left">
            <i class="glyphicon glyphicon-comment"> </i>
          </div>
          <div class="media-body">
            <h4 class="media-heading">
              <!-- Use Angular's sanitize? ng-bind-html? Could not find a "safe" filter. -->
              <pre>{{ 'cur_basket.comment' | ng }}</pre>
            </h4>
          </div>
        </div>

        <div ng-show="showing_notes">
          <div><textarea cols="80" rows="6" ng-model="cur_basket.comment"></textarea>
          </div>
          <button ng-click="save_basket()" class="button btn btn-default">{% trans "Save" %}</button>
        </div>
        {% endif %}

        <div ng-show="cur_basket.sold_date">
          <div>{% trans "Sold date" %}: {{ 'cur_basket.sold_date' | ng }}</div>
        </div>

        <!-- No content?  -->
        <!-- <div ng-hide="copies.length" style="height: 30%; width: 30%" class="middle">
             <em ng-hide="cur_basket.id == -99">
             {% trans "This list has no books inside… yet." %}
             </em>
             <em ng-show="cur_basket.id == -99">
             {% trans "Scan any book to return here. It will be registered for its supplier." %}
             </em>

             </div>
        -->
        <!-- <div ng-hide="copies.length || cur_basket.id == -99" style="height: 80%; width: 30%" class="middle">
             <img src="/static/search/bee.png" height="200px" style="opacity: 0.7"/>
             </div>
        -->

        <div class="col-md-7" style="margin-top: -1em; margin-bottom: -2em">
          <div class="btn-group btn-sm"><span aria-label="page navigation" class="text-right">
            <ul ng-show="copies.length" class="pagination">
              <li class="page-item"><a ng-click="firstPage()" class="page-link">&laquo;</a>
              </li>
              <li class="page-item"><a ng-click="previousPage()" class="page-link"><</a>
              </li>
              <li class="page-item"><a class="page-link">Page {{ 'page' | ng }} / {{ 'meta.num_pages' | ng }} ({{ 'meta.nb_results' | ng }})</a>
              </li>
              <li class="page-item"><a ng-click="nextPage()" class="page-link">></a>
              </li>
              <li class="page-item"><a ng-click="lastPage()" class="page-link">&raquo;</a>
              </li>
            </ul></span>
          </div>
          <div class="btn-group">
            <select ng-show="copies.length" ng-model="page_size" ng-options="it for it in page_sizes" style="width: 5em" class="form-control btn-sm"></select>
          </div>
        </div>

        <div>
          {% if copies %}
          {% include "search/client_institution_basket_content.html" with copies=copies %}
          {% elif content %}
          {% include "search/client_institution_basket_content.html" with content=content %}
          {% endif %}
        </div>

        <table ng-cloak="ng-cloak" ng-show="copies.length" class="table table-condensed table-striped">
          <thead>
            <th ng-show="show_images" class="mouse-pointer"></th>
            <th ng-click="sort_by('title')" class="mouse-pointer">{% trans "Title" %}<span class="caret"></span>
            </th>
            <th ng-click="sort_by('pubs_repr')" onclick="sort_by('title')" title="click to sort" class="mouse-pointer">{% trans "Publisher" %}<span ng-click="sort_by('pubs_repr')" class="caret"></span>
            </th>
            <th ng-click="sort_by('dist_repr')" title="click to sort" class="mouse-pointer">{% trans "Supplier" %}<span class="caret"></span>
            </th>
            <th ng-click="sort_by('created')" class="mouse-pointer">{% trans "Publication date" %}<span class="caret"></span>
            </th>
            <th ng-click="sort_by('modified')" class="mouse-pointer">{% trans "Modified" %}<span class="caret"></span>
            </th>
            <th ng-click="sort_by('quantity')" title="click to sort" class="mouse-pointer">{% trans "In stock" %}<span class="caret"></span>
            </th>{% if  FEATURE_BASKETS_SHOW_DEPOSIT_QUANTITIES %}
            <th ng-click="sort_by('nb_current_deposit')" title="click to sort" class="mouse-pointer">{% trans "In deposit" %}</th>{% endif %}
            <th ng-click="sort_by('price')" title="click to sort" class="mouse-pointer text-right">{% trans "Price" %}<span class="caret"></span>
            </th>
            <th ng-click="sort_by('basket_qty')" title="click to sort" class="mouse-pointer"><span class="caret"></span>
            </th>
          </thead>
          <tbody>
            <tr>
              <td ng-show="show_images">
                <div class="col-md-6"></div>
              </td>
              <td>{% trans "Total" %}</td>
              <td></td>
              <td></td>
              <td></td>
              <td></td>
              <td></td>{% if  FEATURE_BASKETS_SHOW_DEPOSIT_QUANTITIES %}
              <td></td>{% endif %}
              <td>{{ 'get_total_price()'|ng}} {{ 'meta.default_currency' | ng }}</td>
              <td>{{ 'get_total_copies()'|ng}}</td>
              <td></td>
            </tr>
            <tr ng-repeat="card in copies" class="my-animated-item">
              <td ng-show="show_images">
                <div ng-show="show_images" class="col-md-6">

                  <!-- Click to enlarge image. -->
                  <a data-toggle="modal"
                      data-target="#enlargeImageModal{{ 'card.id' | ng }}"
	              title="{% trans 'Enlarge image' %}">
                    <img ng-show="card.img" ng-src="{{ 'card.img' | ng }}" class="myImg mouse-pointer"/>
                  </a>
                </div>

                <!-- enlargeImageModal ci-dessous: -->
                <div id="enlargeImageModal{{ 'card.id' | ng }}" class="modal">
                  {% include "search/modale_enlarge_image_body.html" %}
                </div>


              </td>
              <td>
                <div class="col-md-12"><span ng-hide="card.isbn" title="Cette notice n'a pas d'ISBN. Elle ne peut pas être commandée via Dilicom.">
                  <i class="glyphicon glyphicon-warning-sign">&nbsp;</i>
                </span><span><a href="{{ 'card.get_absolute_url' | ng}}">{{ 'card.title' | ng }}</a><span ng-show="card.isbn && ! show_images" style="color: dimgrey; padding-left: 1em; font-size: 90%">{{ 'card.isbn' | ng }}</span></span>
                <div ng-show="show_images">{{'card.authors_repr'|ng}}</div>
                <div ng-show="show_images" style="color: dimgrey;">{{ 'card.isbn' | ng }}</div>
                <div ng-show="show_images" class="badge badge-secondary"> {{'card.shelf'|ng}} </div>
                </div>
              </td>
              <td>{{ 'card.pubs_repr' | ng }}</td>
              <td id="suppliercard{{ 'card.id ' | ng }}" style="font-size: 90%">{{ 'card.dist_repr' | ng }}</td>
              <td>{{ 'card.date_publication_short' | ng }}</td>
              <td>{{ 'card.modified_short' | ng }}</td>
              <td class="text-right">{{ 'card.quantity' | ng}}</td>{% if  FEATURE_BASKETS_SHOW_DEPOSIT_QUANTITIES %}
              <td class="text-right">{{ 'card.qty_deposits' | ng}}</td>{% endif %}
              <td class="text-right">{{ 'card.price_fmt' | ng }}</td>
              <td>
                <input type="number" min="0" max="99" ng-model="card.basket_qty" ng-change="save_quantity($index)" class="my-number-input"/>
              </td>
              <td>
                <i ng-click="remove_from_selection($index)"
                    ng-hide="cur_basket.id == -99"
                    style="padding-left: 1em;"
                    class="glyphicon glyphicon-remove mouse-pointer my_remove">

                </i>
              </td>
            </tr>
          </tbody>
        </table>

        <div class="col-md-7">
          <div class="btn-group btn-sm"><span aria-label="page navigation" class="text-right">
            <ul ng-show="copies.length" class="pagination">
              <li class="page-item"><a ng-click="firstPage()" class="page-link">&laquo;</a>
              </li>
              <li class="page-item"><a ng-click="previousPage()" class="page-link"><</a>
              </li>
              <li class="page-item"><a class="page-link">Page {{ 'page' | ng }} / {{ 'meta.num_pages' | ng }} ({{ 'meta.nb_results' | ng }})</a>
              </li>
              <li class="page-item"><a ng-click="nextPage()" class="page-link">></a>
              </li>
              <li class="page-item"><a ng-click="lastPage()" class="page-link">&raquo;</a>
              </li>
            </ul></span>
          </div>
          <div class="btn-group">
            <select ng-show="copies.length" ng-model="page_size" ng-options="it for it in page_sizes" style="width: 5em" class="form-control btn-sm"></select>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

<script>
  htmx.on("ok", function(evt) {
    Notiflix.Notify.Success("OK");
  });
</script>

{% endblock content %}
